// global download dialog window
var gClShow = null;

/********************************************************/

function doLoad() {
  gClShow = new ClShow();
  gClShow.start();
  return true;
}


function doUnload() {
  gClShow.stop();
  gClShow = null;
}

/********************************************************/

function ClShow() {
  return this;
}


ClShow.prototype = {
  
  _atomService: null,
  _utils: null,
  _manager: null,
  _managerCenter: null,
  _settings: null,
  _provider: null,
  _accountId: "",
  _rateplan: "",
  
  _headers: null,
  _headerList: [ "index", "time", "number", "duration", "fee", "credit" ],
  _headerNames: {                   // essential headers
    "index": "#",
    "time":  "Datum/Uhrzeit",
    "number": "Rufnummer",
    "duration": "Dauer",
    "fee": "Entgelt",
    "credit": "Gutschrift" },
  _headerFormats: {
    "index": "integer",
    "time":  "datetime",
    "number": "string",
    "duration": "duration",
    "fee": "fixed",
    "credit": "float" },
  _months: [ "J\u00E4nner", "Februar", "M\u00E4rz", "April", "Mai",
             "Juni", "Juli", "August", "September", "Oktober",
             "November", "Dezember" ],
  
  _finalFormats: null,
  
  _callsdir: "",
  
  _callsArray: null,
  _sum_time: 0,
  _sum_cost: 0,
  
  _selMonth: -1,
  _selYear: -1,
  _selType: -1,
  
  _fromDate: 0,
  _toDate: 0,
  
  /******************************************************/
  
  start: function(aWindow) {
    var arg = window.arguments[0];
    this._provider = arg.provider;
    this._accountId = arg.id;
    this._rateplan = arg.rateplan;
    
    this._atomService = Components.classes["@mozilla.org/atom-service;1"].
                          getService(Components.interfaces.nsIAtomService);
    this._utils = Components.classes["@mozdev.org/checkyesss/util_service;1"].
                getService(Components.interfaces.cyICheckyesssUtil);
    this._managerCenter = Components.classes["@mozdev.org/checkyesss/manager_center;1"].
                            getService(Components.interfaces.cyICheckyesssCenter);
    
    this._settings = Components.classes["@mozdev.org/checkyesss/settings_service;1"].
                       getService(Components.interfaces.cyICheckyesssSettings);
    
    this._manager = this._managerCenter.getManager(this._provider);
    
    document.title = "Gespr\u00E4chsdaten des Kontos '" + this._accountId + "'";
    
    document.getElementById("clshow-tree").view = this;
    
    setTimeout("gClShow._updateCalls();", 100);
  },
  
  /******************************************************/
  
  stop: function() {
    //destroy variables
    this._manager = null;
    this._settings = null;
    this._managerCenter = null;
    this._callsArray = null;
    this._accountId = null;
    this._utils = null;
    this.treebox = null;
    this._atomService = null;
  },
  
  /******************************************************/
  
  doCancel: function() {
    window.close();
  },
  
  /******************************************************/
  
  doStore: function() {
    var settings, global;
    var store = false;
    var olddir;
    
    if (!this._callsdir) {
      // read the directory from the global settings
      settings = Components.classes["@mozdev.org/checkyesss/settings_service;1"].
                   getService(Components.interfaces.cyICheckyesssSettings);
      global = settings.getGlobalSettings();
      if (global.hasProperty("store-calls-dir"))
        this._callsdir = global.getPropertyAsString("store-calls-dir");
      
      if (!this._callsdir) {
        // default to home directory
        var dirs = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
        var folder = dirs.get("Home", Components.interfaces.nsIFile);
        this._callsdir = folder.path;
        store = true;
      }
    }
    olddir = this._callsdir;
    
    this._storeCalls();
    
    if (store ||                        // first time saving dir to settings, OR
        this._callsdir != olddir) {     // user changed the directory
      // store the new directory in the global settings
      global.setPropertyAsString("store-calls-dir", this._callsdir);
      settings.writeModifiedSettings(false);
    }
  },
  
  /******************************************************/
  
  _updateCalls: function() {
    var i;
    
    var args = {
      "provider": this._provider,
      "id": this._accountId,
      "aborted": false };
    
    window.openDialog("chrome://checkyesss/content/calls-dlwait.xul",
                      "checkyesss-window-dlwait",
                      "chrome,modal,centerscreen",
                      args);
    
    this._dateFrom = new Date(this._utils.getFirstCallTime(this._accountId));
    this._dateTo   = new Date(this._utils.getLastCallTime(this._accountId));
    //dump("from "+dateFrom.toString()+", to "+dateTo.toString()+"\n");
    
    this._finalFormats = new Object();
    
    // first get the default headers
    this._headers = new Array();
    var container, shortcut;
    for (i = 0; i < this._headerList.length; i++) {
      shortcut = this._headerList[i];
      container = Components.classes["@mozdev.org/checkyesss/container;1"].
                    createInstance(Components.interfaces.cyICheckyesssContainer);
      container.setPropertyAsString("shortcut", shortcut);
      container.setPropertyAsString("cleartext", this._headerNames[shortcut]);
      container.setPropertyAsString("format", this._headerFormats[shortcut]);
      container.setPropertyAsBool("shortView", true);
      container.setPropertyAsBool("extendedView", true);
      container.setPropertyAsBool("fileView", true);
      this._headers.push(container);
      this._finalFormats[shortcut] = this._headerFormats[shortcut];
    }
    
    // now add the custom headers
    var hds = this._managerCenter.getCallsHeaderProperties(this._provider, this._rateplan);
    var hd;
    var found;
    while (hds.hasMoreElements()) {
      hd = hds.getNext().QueryInterface(Components.interfaces.cyICheckyesssContainer);
      shortcut = hd.getPropertyAsString("shortcut");
      this._finalFormats[shortcut] = hd.getPropertyAsString("format");
      found = false;
      for (i = 0; i < this._headers.length; i++) {
        found = found ||
                (this._headers[i].getPropertyAsString("shortcut") == shortcut);
        if (found)
        {
          // remove the found column definition and shrink the array
          if ((i + 1) < this._headers.length)
            this._headers[i] = this._headers[i + 1];
          else
            this._headers.length--;
        }
      }
      // append the new column definition
      this._headers.push(hd);
    }
    
    this._updateColHeaders();
    this._updatePeriodList();       // plus: select most recent period
    this._updateCallsList();
  },
  
  /******************************************************/
  
  _updatePeriodList: function() {
    var typeElem = document.getElementById("clshow-type");
    var account = this._settings.getAccountSettings(this._accountId);
    var preset = account.getPropertyAsString("period-reset");
    var selType;
    
    if (this._selType < 0) {             // execute this just once
      this._applyPersistentValues(typeElem);
      selType = typeElem.hasAttribute("selectedIndex") ?
                  Number(typeElem.getAttribute("selectedIndex")) : 0;
      if (isNaN(selType) || (selType < 0) || (selType > 1))
        selType = 0;
      typeElem.selectedIndex = selType;
      typeElem.setAttribute("selectedIndex", ""+selType);  // to get it persistent
      
      var prop = this._managerCenter.getRatePlanProperties(this._provider, 
                                                           this._rateplan);
      if (!prop || !prop.getPropertyAsBool("userResetPeriod") ||
          typeof(preset) == "undefined" ||
          !preset.match(/^\s*(?:\d|manual)/)) {
        // no support for manual accounting periods
        typeElem.setAttribute("hidden", "true");
        selType = 0;
      }
    }
    else {
      selType = typeElem.selectedIndex;
      typeElem.setAttribute("selectedIndex", ""+selType);  // to get it persistent
    }
    
    if (selType == this._selType)          // no change
      return;
    
    this._selMonth = -1;
    this._selYear = -1;
    this._selType = selType;
    
    // clear list of months / periods, just keep the "full year" entry
    var monthList = document.getElementById("clshow-month");
    while (monthList.removeItemAt(1)) { null; }
    var yearList = document.getElementById("clshow-year");
    while (yearList.removeItemAt(0)) { null; }
    
    var yearFrom = this._dateFrom.getFullYear();
    var yearTo   = this._dateTo.getFullYear();
    
    if (yearFrom < 1980 || yearTo < 1980) {
      yearList.insertItemAt(0, "--", "--");
      monthList.selectedIndex = 0;
      return;
    }
    
    var day, i;
    
    if (selType == 0) {
      // user wants to see full months
      for (i = this._months.length - 1; i >= 0; i--)
        monthList.insertItemAt(1, this._months[i], "1");
      
      for (i = yearTo; i >= yearFrom; i--) {
        yearList.insertItemAt(0,
                              i.toString(),
                              i.toString());
      }
      
      // select month of last call
      yearList.selectedIndex = yearTo - yearFrom;
      monthList.selectedIndex = this._dateTo.getMonth() + 1;
    }
    else {
      if (preset.match(/^\s*(?:\d)/)) {
        // period starts at a certain day each month
        day = Number(preset);
        for (i = this._months.length - 1; i >= 0; i--) {
          if (i == 1 && day > 28)
            monthList.insertItemAt(1, "ab 1. "+this._months[i+1], preset);
          else
            monthList.insertItemAt(1, "ab "+day+". "+this._months[i], preset);
        }
        
        for (i = yearTo; i >= yearFrom; i--) {
          yearList.insertItemAt(0,
                                i.toString(),
                                i.toString());
        }
        
        // select month of last call
        yearList.selectedIndex = yearTo - yearFrom;
        monthList.selectedIndex = this._dateTo.getMonth() + 1;
        // BUGFIX: Correct month if period would start after last month
        if (this._dateTo.getDate() < day)
        {
          if (monthList.selectedIndex > 1)
            monthList.selectedIndex--;
          else
          if (yearList.selectedIndex > 0)
          {
            yearList.selectedIndex--;
            monthList.selectedIndex = 12;
          }
        }
      }
      else {
        // period starts at a user-defined date
        var dateStartNum = (preset.match(/^\s*manual-\d/)) ? 
                             preset.match(/^\s*manual-(\d+)/)[1] : 0;
        var dateStart = new Date(Number(dateStartNum));
        if (dateStart.getFullYear() >= 1980) {
          monthList.insertItemAt(1, "seit " + dateStart.getDate() + ". " +
                                    this._months[dateStart.getMonth()],
                                    dateStartNum);
          yearList.insertItemAt(0, "" + dateStart.getFullYear(),
                                   "" + dateStart.getFullYear());
        }
        else {
          monthList.insertItemAt(1, "seit Beginn", 100);
          yearList.insertItemAt(0, "--", "0");
        }
        monthList.selectedIndex = 1;
        yearList.selectedIndex = 0;
      }
    }
  },
  
  /******************************************************/
  
  _applyPersistentValues: function(aElement) {
    var id = aElement.getAttribute("id");
    var persist = aElement.getAttribute("persist");
    var attr;
    if (persist) {
      attr = persist.split(" ");
    }
    if (!id || !persist || !attr)
      return;
    
    var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].
                       getService(Components.interfaces.nsIRDFService);
    var localstore = rdfService.GetDataSource("rdf:local-store");
    var element = rdfService.GetResource(document.documentURI + "#" + id);
    
    var ares, target, i;
    
    for (i = 0; i < attr.length; i++) {
      ares = rdfService.GetResource(attr[i]);
      target = localstore.GetTarget(element, ares, true);
      if (target instanceof Components.interfaces.nsIRDFLiteral)
        aElement.setAttribute(attr[i], target.Value);
    }
  },
  
  /******************************************************/
  
  _updateColHeaders: function() {
    var treecols = document.getElementById("clshow-treecols");
    while (treecols.lastChild)
      treecols.removeChild(treecols.lastChild);
    
    var showmore = document.getElementById("showmore").checked;
    
    var i, colnum, col, flex, splitter, header, shortcut;
    
    colnum = 0;
    for (i = 0; i < this._headers.length; i++) {
      header = this._headers[i];
      
      if (!((showmore && header.getPropertyAsBool("extendedView")) ||
            (!showmore && header.getPropertyAsBool("shortView"))))
        continue;
      
      if (colnum > 0) {
        // insert a splitter
        splitter = document.createElement("splitter");
        splitter.setAttribute("class", "tree-splitter");
        treecols.appendChild(splitter);
      }
      
      shortcut = header.getPropertyAsString("shortcut");
      
      col = document.createElement("treecol");
      col.setAttribute("id", "h_" + shortcut);
      col.setAttribute("label", header.getPropertyAsString("cleartext"));
      col.setAttribute("persist", "width ordinal hidden");
      
      if (shortcut == "fee" || shortcut == "credit" ||
          shortcut == "download" || shortcut == "upload")
        col.setAttribute("style", "text-align: right;");
      
      flex = (shortcut == "index") ? 1 :
             (shortcut == "number") ? 3 : 2;
      col.setAttribute("flex", flex);
      
      col = treecols.appendChild(col);
      
      this._applyPersistentValues(col);
      colnum++;
    }
  },
  
  /******************************************************/
  
  _updateCallsList: function() {
    var selMonth = document.getElementById("clshow-month").selectedIndex;
    var selMonthDay = Number(document.getElementById("clshow-month").value);
    var selYear  = Number(document.getElementById("clshow-year").value);
    
    // check if there has been a change
    if (selMonth == this._selMonth &&
        selYear  == this._selYear)
      return;
    
    if (this.rowCount > 0)
      this.treebox.rowCountChanged(0, -this.rowCount);
    this.rowCount = 0;
    this._callsArray = new Array();
    
    if (isNaN(selYear))
      return;
    
    if (selMonth == 0) {
      // whole year
      this._fromDate = (new Date(selYear, 0, 1, 0, 0, 0, 0)).valueOf();
      this._toDate = (new Date(selYear+1, 0, 1, 0, 0, 0, 0)).valueOf() - 1;
    }
    else if (selMonthDay <= 31) {
      if (selMonth == 2 && selMonthDay > 28)
        this._fromDate = (new Date(selYear, selMonth, 1, 0, 0, 0, 0)).valueOf();
      else
        this._fromDate = (new Date(selYear, selMonth - 1, selMonthDay, 0, 0, 0, 0)).valueOf();
      
      if (selMonth == 1 && selMonthDay > 28)
        this._toDate = (new Date(selYear, selMonth + 1, 1, 0, 0, 0, 0)).valueOf() - 1;
      else
        this._toDate = (new Date(selYear, selMonth, selMonthDay, 0, 0, 0, 0)).valueOf() - 1;
    }
    else {
      this._fromDate = selMonthDay;
      this._toDate = (new Date()).valueOf();       // now
    }
    
    var calls = this._manager.getCallsRecords(this._accountId,
                                              this._fromDate,
                                              this._toDate,
                                              null);
    var call;
    
    while (calls.hasMoreElements()) {
      call = calls.getNext().QueryInterface(Components.interfaces.cyICheckyesssContainer);
      this._callsArray.push(call);
    }
    
    if (this._callsArray.length > 0) {
      document.getElementById("store").removeAttribute("disabled");
    }
    else {
      document.getElementById("store").setAttribute("disabled", "true");
      
      call = Components.classes["@mozdev.org/checkyesss/container;1"].
               createInstance(Components.interfaces.cyICheckyesssContainer);
      call.setPropertyAsBool("statistic", true);
      call.setPropertyAsString("description", "keine Verbindungen");
      this._callsArray.push(call);
    }
    
    this.rowCount = this._callsArray.length;
    this.treebox.rowCountChanged(0, this.rowCount);
    this.treebox.invalidate();
    
    this._selMonth = selMonth;
    this._selYear = selYear;
  },
  
  /******************************************************/
  
  // nsITreeView interface ---------------------------------
  
  rowCount: 0,
  getCellText: function(row, column) {
    var col = (typeof column == "string") ? column : column.id;
    var result = "";
    
    if (this._callsArray) {
      var element = this._callsArray[row];
      var header = col.replace(/^h_/, "");
      
      if (!(element.hasProperty("statistic") &&
            element.getPropertyAsBool("statistic"))) {
        if (header == "index") {
          result = row + 1;
        }
        else if (element.hasProperty(header)) {
          var format = this._finalFormats[header];
          switch(format) {
            case "datetime":
              result = this._time2string(element.getPropertyAsInt(header));
              break;
            case "duration":
              result = this._duration2string(element.getPropertyAsInt(header));
              break;
            case "fixed":
            case "float":
              result = element.getPropertyAsString(header).replace(/\./, ",");
              break;
            default:
              result = element.getPropertyAsString(header);
              break;
          }
        }
      }
      else {
        if (header == "duration" &&
            element.hasProperty("duration") &&
            element.getPropertyType("duration") == "number")
          result = this._duration2string(element.getPropertyAsInt("duration"));
        else
          result =
            (header == "number" && this._finalFormats["number"]) ?
              element.getPropertyAsString("description") :
            (header == "time" && !this._finalFormats["number"]) ?
              element.getPropertyAsString("description") :
            element.hasProperty(header) ?
              element.getPropertyAsString(header) : "";
      }
    }
    //dump("update: "+col+"-"+row+" := '"+result+"'\n");
    return result;
  },
  
  getCellProperties: function(row, column, props){
    var col = (typeof column == "string") ? column : column.id;
    //var header = col.replace(/^h_/, "");     removed for speed-up
    if (col == "h_fee" || col == "h_credit" ||
        col == "h_upload" || col == "h_download")
      props.AppendElement(this._atomService.getAtom("money"));
    if (this._callsArray) {
      var element = this._callsArray[row];
      if (element.hasProperty("statistic") &&
          element.getPropertyAsBool("statistic"))
        props.AppendElement(this._atomService.getAtom("statistic"));
    }
    // could be optimized by preparing the atoms beforehand
  },
  
  treebox: null,
  setTree: function(treebox){ this.treebox = treebox; },
  isContainer: function(row){ return false; },
  isSeparator: function(row){ return false; },
  isSorted: function(row){ return false; },
  getLevel: function(row){ return 0; },
  getImageSrc: function(row,col){ return null; },
  getRowProperties: function(row,props) { return; },
  getColumnProperties: function(colid,col,props) { return; },
  cycleHeader: function(col,elem) {
    if (!elem) elem = col.element;
    // do nothing
    return;
  },
  
  // -------------------------------------------------------
  
  _storeCalls: function() {
    var dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    dir.initWithPath(this._callsdir);
    
    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
    fp.init(window, "Gespr\u00E4chsdaten speichern unter...", 
            nsIFilePicker.modeSave);
    fp.appendFilter("Text CSV","*.csv; *.txt");
    fp.appendFilter("Open Documents Spreadsheet","*.ods");
    fp.appendFilter("Alle Dateien","*.*");
    fp.displayDirectory = dir;
    fp.defaultString = "";
    
    var res = fp.show();
    var file = fp.file;
    var index = fp.filterIndex;
    var fname;
    
    if (res == nsIFilePicker.returnOK) {           // a new file
      fname = file.path;
      switch(index) {
        case 1:                                    // ODS selected
          if (!fname.match(/\.(ods|csv|txt)$/))
            fname += ".ods";
          break;
        default:                                   // default is CSV (still)
          if (!fname.match(/\.(ods|csv|txt)$/))
            fname += ".csv";
          break;
      }
      file.initWithPath(fname);
    }
    if (res != nsIFilePicker.returnCancel) {
      fname = file.path;
      this._callsdir = file.parent.path;
      switch(index) {
        case 1:                                    // ODS selected
          if (fname.match(/\.(csv|txt)$/))
            index = 0;
          break;
        default:                                   // default is CSV (still)
          index = 0;
          if (fname.match(/\.ods$/))
            index = 1;
          break;
      }
      switch (index) {
        case 0:
          this._write_csv(file);
          break;
        case 1:
          this._write_opendoc(file);
          break;
        default:
          // should never be reached!
          this._write_csv(file);
          break;
      }
    }
  },
  
  
  _write_csv: function(aFile) {
    var i, j, line, header, headers, num, div, result, element;
    
    var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].
                      createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
    converter.charset = "UTF-8";
    
    var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    if (aFile.exists())
      aFile.remove(false);
    aFile.create(file.NORMAL_FILE_TYPE, 0644);
    var flags = 0x02 | 0x08 | 0x20;
    var streamout = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
    streamout.init(aFile, flags, 0644, null);
    
    line  = "\"Einzelgespr\u00E4che des Kontos '" + this._accountId + "'\"\n";
    
    var selMonth = document.getElementById("clshow-month").selectedIndex;
    var selYear  = Number(document.getElementById("clshow-year").value);
    
    if (selMonth > 0) {
      var now = (new Date()).valueOf();
      var date = new Date(this._fromDate);
      if (date.getFullYear() >= 1980) {
        line += "\"vom " + date.getDate() + ". " + this._months[date.getMonth()];
      }
      else {
        line += "\"seit Beginn ";
      }
      date = new Date((this._toDate < now) ? this._toDate : now);
      line += " bis " + date.getDate() + ". " + this._months[date.getMonth()] +
              " " + date.getFullYear() + "\"\n";
    }
    else
      line += "\"im Jahr " + selYear + "\"\n";
    
    line += "\"Stand ";
    var written = this._utils.getCallsWritten(this._accountId);
    if (written > 0) {
      written = new Date(written);
      line += written.getDate()+"."+(written.getMonth()+1)+"."+written.getFullYear();
    }
    else
      line += "??";
    line += "\"\n\"\"\n";
    
    line = converter.ConvertFromUnicode(line);
    line += converter.Finish();
    streamout.write(line, line.length);
    
    line = "";
    headers = new Array();
    for (i = 0; i < this._headers.length; i++) {
      header = this._headers[i];
      if (header.getPropertyAsBool("fileView")) {
        if (headers.length)
          line += ";";
        line += "\"" + header.getPropertyAsString("cleartext") + "\"";
        headers.push(header.getPropertyAsString("shortcut"));
      }
    }
    
    line += "\n";
    line = converter.ConvertFromUnicode(line);
    line += converter.Finish();
    streamout.write(line, line.length);
    
    if (this._callsArray) {
      // go through all calls
      for (i = 0; i < this._callsArray.length; i++) {
        line = "";
        element = this._callsArray[i];
        
        // cycle through all columns
        for (j = 0; j < headers.length; j++) {
          header = headers[j];
          
          result = "";
          
          if (!(element.hasProperty("statistic") &&
                element.getPropertyAsBool("statistic"))) {
            if (header == "index") {
              result = i + 1;
            }
            else if (element.hasProperty(header)) {
              var format = this._finalFormats[header];
              switch(format) {
                case "datetime":
                  result = this._time2string(element.getPropertyAsInt(header));
                  break;
                case "duration":
                  result = this._duration2string(element.getPropertyAsInt(header));
                  break;
                case "fixed":
                case "float":
                  result = this._float2fraction(element.getPropertyAsString(header));
                  if (result.length)
                    result = "=" + result;
                  break;
                default:
                  result = '="' + element.getPropertyAsString(header) + '"';
                  break;
              }
            }
          }
          else {
            if (header == "duration" &&
                element.hasProperty("duration") &&
                element.getPropertyType("duration") == "number")
              result = this._duration2string(element.getPropertyAsInt("duration"));
            else  
              result =
                (header == "number")   ? element.getPropertyAsString("description") :
                element.hasProperty(header) ? ("=\"" + element.getPropertyAsString(header) + "\"") : "";
          }
          
          line += result;
          if (j < headers.length - 1)
            line += ";";
        }
        line += "\n";
        line = converter.ConvertFromUnicode(line);
        line += converter.Finish();
        streamout.write(line, line.length);
      }
    }
    
    streamout.close();
  },
  
  
  _write_opendoc: function(aFile) {
    var error = "";
    var ok = true;
    
    var zip = Components.classes["@mozdev.org/checkyesss/zip_writer;1"].
                createInstance(Components.interfaces.cyICheckyesssZipWriter);
    if (aFile.exists())
      aFile.remove(false);
    try {
      zip.wrappedJSObject.setJava(java);
    }
    catch (e) {
      error = "Fehlende Java-Unterst\u00FCtzung";
      ok = false;
    }
    if (ok) {
      try {
        ok = zip.createZipFile(aFile.path);
        error = zip.error;
      }
      catch (e) {
        error = "Fehlende Java-Unterst\u00FCtzung";
        ok = false;
      }
    }
    
    if (!ok) {
      alert("Datei konnte nicht erstellt werden!\nGrund: " + error);
      return;
    }
    
    now = new Date();
    date = now.getFullYear()+"-"+(now.getMonth()+1)+"-"+now.getDate()+"T"+
           now.getHours()+":"+now.getMinutes()+":"+now.getSeconds();
    date = date.replace(/([^\d])(\d)([^\d]|$)/g, "${1}0$2$3");
    zip.addFile("meta.xml");
    zip.addContents("<?xml version='1.0' encoding='UTF-8'?>\n" +
      "<office:document-meta\n" +
      "    xmlns:office='urn:oasis:names:tc:opendocument:xmlns:office:1.0'\n" +
      "    xmlns:dc='http://purl.org/dc/elements/1.1/'\n" +
      "    xmlns:meta='urn:oasis:names:tc:opendocument:xmlns:meta:1.0'\n" +
      "    office:version='1.0'>\n" +
      "  <office:meta>\n    <meta:generator>Checkyesss</meta:generator>\n" +
      "    <meta:creation-date>" + date + "</meta:creation-date>\n" +
      "    <dc:language>de-AT</dc:language>\n  </office:meta>\n" +
      "</office:document-meta>",
      "UTF-8");
    
    zip.addFile("META-INF/manifest.xml");
    zip.addContents("<?xml version='1.0' encoding='UTF-8'?>\n" +
      "<manifest:manifest xmlns:manifest='urn:oasis:names:tc:opendocument:xmlns:manifest:1.0'>\n" +
      "  <manifest:file-entry manifest:media-type='application/vnd.oasis.opendocument.spreadsheet' manifest:full-path='/'/>\n" +
      "  <manifest:file-entry manifest:media-type='text/xml' manifest:full-path='content.xml'/>\n" +
      "  <manifest:file-entry manifest:media-type='text/xml' manifest:full-path='styles.xml'/>\n" +
      "  <!--manifest:file-entry manifest:media-type='text/xml' manifest:full-path='Obj1/content.xml'/>\n" +
      "  <manifest:file-entry manifest:media-type='text/xml' manifest:full-path='Obj1/styles.xml'/-->\n" +
      "  <manifest:file-entry manifest:media-type='application/vnd.oasis.opendocument.chart' manifest:full-path='Obj1/'/>\n" +
      "  <manifest:file-entry manifest:media-type='text/xml' manifest:full-path='meta.xml'/>\n" +
      "</manifest:manifest>\n",
      "UTF-8");
    
    var data_empty = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"+
                     "<data/>\n";
    
    var parser = Components.classes["@mozilla.org/xmlextras/domparser;1"].
                   createInstance(Components.interfaces.nsIDOMParser);
    var doc = parser.parseFromString(data_empty, "text/xml");
    
    var serializer = Components.classes["@mozilla.org/xmlextras/xmlserializer;1"].
                       createInstance(Components.interfaces.nsIDOMSerializer);
    
    var top = doc.documentElement;
    var calls = doc.createElement("calls");
    var columns = doc.createElement("columns");
    
    //== populate info element ==
    
    var info = doc.createElement("info");
    var value, el, i;
    
    info.setAttribute("accid", this._accountId);
    
    var selMonth = document.getElementById("clshow-month").selectedIndex;
    var selYear  = Number(document.getElementById("clshow-year").value);
    
    if (selMonth > 0) {
      var now = (new Date()).valueOf();
      var date = new Date(this._fromDate);
      if (date.getFullYear() >= 1980) {
        value = "vom " + date.getDate() + ". " + this._months[date.getMonth()];
      }
      else {
        value = "seit Beginn ";
      }
      date = new Date((this._toDate < now) ? this._toDate : now);
      value += " bis " + date.getDate() + ". " + this._months[date.getMonth()] +
               " " + date.getFullYear();
    }
    else
      value = "im Jahr " + selYear;
    
    info.setAttribute("range", value);
    
    var written = this._utils.getCallsWritten(this._accountId);
    if (written > 0) {
      written = new Date(written);
      value = written.getDate() + ". " +
              this._months[written.getMonth()] + " " +
              written.getFullYear();
    }
    else
      value = "??";
    
    info.setAttribute("today", value);
    
    var decimals = this._managerCenter.getUsedFeeDecimals(this._provider, this._rateplan);
    info.setAttribute("decimals", ""+decimals);
    
    top.appendChild(info);
    
    //== populate header elements ==
    
    for (i = 0; i < this._headers.length; i++) {
      header = this._headers[i];
      if (header.getPropertyAsBool("fileView")) {
        el = doc.createElement("header");
        name = header.getPropertyAsString("shortcut");
        format = header.getPropertyAsString("format");
        if (format == "datetime" || format == "duration")
          name = "ods-" + name;
        el.setAttribute("name", name);
        el.setAttribute("title", header.getPropertyAsString("cleartext"));
        el.setAttribute("format", format);
        columns.appendChild(el);
      }
    }
    
    calls.appendChild(columns);
    
    //== populate call elements ==
    
    var call;
    
    if (this._callsArray) {
      // go through all calls
      for (i = 0; i < this._callsArray.length; i++) {
        call = this._callsArray[i];
        
        // we cannot handle statistics for now
        if (call.hasProperty("statistic") &&
            call.getPropertyAsBool("statistic"))
          continue;
        
        el = doc.createElement("call");
        call.getPropertiesAsAttributes(el);
        
        el.setAttribute("index", i+1);    // index&sort need some more thinking
        el.setAttribute("sort", i+1);     // 
        
        // cycle through all columns
        for (j = 0; j < this._headers.length; j++) {
          header = this._headers[j];
          if (header.getPropertyAsBool("fileView")) {
            headerName = header.getPropertyAsString("shortcut");
            
            if (call.hasProperty(headerName)) {
              headerFormat = header.getPropertyAsString("format");
              
              if (headerFormat == "datetime" || headerFormat == "duration") {
                newName = "ods-" + headerName;
                if (headerFormat == "datetime")
                  value = this._time2stringODS(call.getPropertyAsInt(headerName));
                else
                  value = this._duration2stringODS(call.getPropertyAsInt(headerName));
                el.setAttribute(newName, value);
              }
              else if (headerFormat == "fixed" || headerFormat == "float") {
                value = el.getAttribute(headerName);
                value = value.replace(/,/, ".");
                el.setAttribute(headerName, value);
              }
            }
          }
        }
        calls.appendChild(el);
      }
    }
    
    top.appendChild(calls);
    //dump(serializer.serializeToString(top, "text/xml") + "\n");
    
    ok = true;
    var request = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].
                    createInstance(Components.interfaces.nsIXMLHttpRequest);
    request.open("GET", "chrome://checkyesss/locale/calls-ods-content.xsl", false);
    request.overrideMimeType("text/xml");
    try {
      request.send(null);
    }
    catch (e) {
      ok = false;
    }
    
    if (ok && request.responseXML) {
      var processor = Components.classes["@mozilla.org/document-transformer;1?type=xslt"].
                         createInstance(Components.interfaces.nsIXSLTProcessor);
      
      processor.importStylesheet(request.responseXML);
      var result = processor.transformToDocument(top);
      zip.addFile("content.xml");
      zip.addXMLContents(result, "UTF-8");
    }
    else {
      this._utils.writeLogEntry(Components.interfaces.cyICheckyesssUtil.LOGLEVEL_ERROR,
                                "_write_opendoc",
                                "Error reading 'chrome://checkyesss/locale/calls-ods-content.xsl':\n" +
                                request.statusText,
                                false);
    }
    
    ok = true;
    request.open("GET", "chrome://checkyesss/locale/calls-ods-styles.xml", false);
    request.overrideMimeType("text/xml");
    try {
      request.send(null);
    }
    catch (e) {
      ok = false;
    }
    if (ok && request.responseXML) {
      zip.addFile("styles.xml");
      zip.addXMLContents(request.responseXML, "UTF-8");
    }
    else {
      this._utils.writeLogEntry(Components.interfaces.cyICheckyesssUtil.LOGLEVEL_ERROR,
                                "_write_opendoc",
                                "Error reading 'chrome://checkyesss/locale/calls-ods-styles.xsl':\n" +
                                request.statusText,
                                false);
    }
    
    zip.closeZipFile();
  },
  
  
  statusInput: function() {
    this._updateCallsList();
  },
  
  
  changePeriod: function() {
    this._updatePeriodList();
    this._updateCallsList();
  },
  
  
  _time2string: function(aDate) {
    var d = new Date(aDate);
    var str = d.getDate().toString().replace(/^(\d)$/, "0$1") + "." +
              (d.getMonth()+1).toString().replace(/^(\d)$/, "0$1") + "." +
              d.getFullYear() + "  " +
              d.getHours().toString().replace(/^(\d)$/, "0$1") + ":" +
              d.getMinutes().toString().replace(/^(\d)$/, "0$1") + ":" +
              d.getSeconds().toString().replace(/^(\d)$/, "0$1");
    return str;
  },
  
  
  _time2stringODS: function(aDate) {
    var d = new Date(aDate);
    var str = d.getFullYear() + "-" +
              (d.getMonth()+1).toString().replace(/^(\d)$/, "0$1") + "-" +
              d.getDate().toString().replace(/^(\d)$/, "0$1") + "T" +
              d.getHours().toString().replace(/^(\d)$/, "0$1") + ":" +
              d.getMinutes().toString().replace(/^(\d)$/, "0$1") + ":" +
              d.getSeconds().toString().replace(/^(\d)$/, "0$1");
    return str;
  },
  
  
/*  _time2string: function(aDate) {
    var d = new Date(aDate);
    var time_str = d.getHours().toString().replace(/^(\d)$/, "0$1") + ":" +
                   d.getMinutes().toString().replace(/^(\d)$/, "0$1") + ":" +
                   d.getSeconds().toString().replace(/^(\d)$/, "0$1");
    return time_str;
  },
  
  
  _date2string: function(aDate) {
    var d = new Date(aDate);
    var date_str = d.getDate()+"."+
                   (d.getMonth()+1)+"."+
                   d.getFullYear();
    return date_str;
  },*/
  
  
  _duration2string: function(aDuration) {
    var result = "";
    var hour = parseInt(aDuration / 3600, 10);
    var min = parseInt(aDuration / 60, 10) - (hour * 60);
    var sec = aDuration - (hour * 3600) - (min * 60);
    result = hour.toString().replace(/^(\d)$/, "0$1") + ":" +
             min.toString().replace(/^(\d)$/, "0$1") + ":" +
             sec.toString().replace(/^(\d)$/, "0$1");
    return result;
  },
  
  
  _duration2stringODS: function(aDuration) {
    var result = "";
    var hour = parseInt(aDuration / 3600, 10);
    var min = parseInt(aDuration / 60, 10) - (hour * 60);
    var sec = aDuration - (hour * 3600) - (min * 60);
    result = "PT" +
             hour.toString().replace(/^(\d)$/, "0$1") + "H" +
             min.toString().replace(/^(\d)$/, "0$1") + "M" +
             sec.toString().replace(/^(\d)$/, "0$1") + "S";
    return result;
  },
  
  
  _float2fraction: function(aFloat) {
    if (aFloat === null || aFloat === "")
      return "";
    
    var result;
    
    if (typeof(aFloat) == "string")
      result = parseFloat(aFloat.replace(/[.,]/, "."));
    
    // get rid of minor imprecitions
    var exp = 6;
    result = "" + Math.round(result * Math.pow(10, exp));
    while ((exp > 0) &&
           (result.length > 1) &&
           (result.charAt(result.length-1) == '0')) {
      exp--;
      result = result.substr(0, result.length-1);
    }
    if ((result != "0") && (exp > 0))
      result += "/" + Math.pow(10, exp);
    
    return result;
  }
  
  
};


