<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:office="urn:oasis:names:tc:opendocument:xmlns:office:1.0"
    xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0"
    xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0"
    xmlns:table="urn:oasis:names:tc:opendocument:xmlns:table:1.0"
    xmlns:draw="urn:oasis:names:tc:opendocument:xmlns:drawing:1.0"
    xmlns:fo="urn:oasis:names:tc:opendocument:xmlns:xsl-fo-compatible:1.0"
    xmlns:xlink="http://www.w3.org/1999/xlink"
    xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:meta="urn:oasis:names:tc:opendocument:xmlns:meta:1.0"
    xmlns:number="urn:oasis:names:tc:opendocument:xmlns:datastyle:1.0"
    xmlns:svg="urn:oasis:names:tc:opendocument:xmlns:svg-compatible:1.0"
    xmlns:chart="urn:oasis:names:tc:opendocument:xmlns:chart:1.0"
    xmlns:dr3d="urn:oasis:names:tc:opendocument:xmlns:dr3d:1.0"
    xmlns:math="http://www.w3.org/1998/Math/MathML"
    xmlns:form="urn:oasis:names:tc:opendocument:xmlns:form:1.0"
    xmlns:script="urn:oasis:names:tc:opendocument:xmlns:script:1.0"
    xmlns:ooo="http://openoffice.org/2004/office"
    xmlns:ooow="http://openoffice.org/2004/writer"
    xmlns:oooc="http://openoffice.org/2004/calc"
    xmlns:dom="http://www.w3.org/2001/xml-events"
    xmlns:xforms="http://www.w3.org/2002/xforms"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    office:version="1.0">

<xsl:output method="xml" indent="yes"/>

<xsl:template match="trend">
<office:document-content><!--
    xmlns:office="urn:oasis:names:tc:opendocument:xmlns:office:1.0"
    xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0"
    xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0"
    xmlns:table="urn:oasis:names:tc:opendocument:xmlns:table:1.0"
    xmlns:draw="urn:oasis:names:tc:opendocument:xmlns:drawing:1.0"
    xmlns:fo="urn:oasis:names:tc:opendocument:xmlns:xsl-fo-compatible:1.0"
    xmlns:xlink="http://www.w3.org/1999/xlink"
    xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:meta="urn:oasis:names:tc:opendocument:xmlns:meta:1.0"
    xmlns:number="urn:oasis:names:tc:opendocument:xmlns:datastyle:1.0"
    xmlns:svg="urn:oasis:names:tc:opendocument:xmlns:svg-compatible:1.0"
    xmlns:chart="urn:oasis:names:tc:opendocument:xmlns:chart:1.0"
    xmlns:dr3d="urn:oasis:names:tc:opendocument:xmlns:dr3d:1.0"
    xmlns:math="http://www.w3.org/1998/Math/MathML"
    xmlns:form="urn:oasis:names:tc:opendocument:xmlns:form:1.0"
    xmlns:script="urn:oasis:names:tc:opendocument:xmlns:script:1.0"
    xmlns:ooo="http://openoffice.org/2004/office"
    xmlns:ooow="http://openoffice.org/2004/writer"
    xmlns:oooc="http://openoffice.org/2004/calc"
    xmlns:dom="http://www.w3.org/2001/xml-events"
    xmlns:xforms="http://www.w3.org/2002/xforms"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    office:version="1.0"-->
    <number:date-style
        style:name="date"
        number:automatic-order="true"
        number:format-source="language">
      <number:day/>
      <number:text>.</number:text>
      <number:month/>
      <number:text>.</number:text>
      <number:year/>
    </number:date-style>
    <number:number-style style:name="decimal">
      <number:number number:decimal-places="0" number:min-integer-digits="1"/>
    </number:number-style>
    <style:style style:name="background" style:family="chart">
      <style:graphic-properties draw:stroke="none" draw:fill-color="#ffffff"/>
    </style:style>
    <style:style style:name="plotarea" style:family="chart">
      <style:chart-properties
          chart:japanese-candle-stick="false"
          chart:stock-with-volume="false"
          chart:three-dimensional="false"
          chart:deep="false"
          chart:lines="true"
          chart:interpolation="none"
          chart:symbol-type="none"
          chart:vertical="false"
          chart:lines-used="0"
          chart:connect-bars="false"
          chart:series-source="columns"
          chart:mean-value="false"
          chart:error-margin="0"
          chart:error-lower-limit="0"
          chart:error-upper-limit="0"
          chart:error-category="none"
          chart:error-percentage="0"
          chart:regression-type="none"
          chart:data-label-number="none"
          chart:data-label-text="false"
          chart:data-label-symbol="false"/>
    </style:style>
    <style:style style:name="x-axis" style:family="chart" style:data-style-name="date">
      <style:chart-properties
          chart:display-label="true"
          chart:link-data-style-to-source="false" 
          chart:tick-marks-major-inner="false"
          chart:tick-marks-major-outer="true"
          chart:logarithmic="false"
          chart:text-overlap="false"
          text:line-break="true"
          chart:label-arrangement="side-by-side"
          chart:visible="true"
          style:direction="ltr"/>
      <style:graphic-properties
          draw:stroke="solid"
          svg:stroke-width="0cm"
          svg:stroke-color="#000000"/>
      <style:text-properties
          fo:font-family="Arial"
          fo:font-size="8.5pt"
          style:font-family-generic="swiss"
          style:font-pitch="variable"/>
    </style:style>
    <style:style style:name="y-axis" style:family="chart" style:data-style-name="decimal">
      <style:chart-properties
          chart:display-label="true"
          chart:tick-marks-major-inner="false"
          chart:tick-marks-major-outer="true"
          chart:tick-marks-minor-inner="false"
          chart:tick-marks-minor-outer="false"
          chart:logarithmic="false"
          chart:minimum="0"
          chart:gap-width="100"
          chart:overlap="0"
          chart:text-overlap="false"
          text:line-break="false"
          chart:label-arrangement="side-by-side"
          chart:visible="true"
          style:direction="ltr"/>
      <style:graphic-properties
          draw:stroke="solid"
          svg:stroke-width="0cm"
          svg:stroke-color="#000000"/>
      <style:text-properties
          fo:font-family="Arial"
          fo:font-size="8.5pt"
          style:font-family-generic="swiss"
          style:font-pitch="variable"/>
    </style:style>
    <style:style style:name="series" style:family="chart">
      <style:chart-properties
          chart:mean-value="false"
          chart:error-margin="0"
          chart:error-lower-limit="0"
          chart:error-upper-limit="0"
          chart:error-category="none"
          chart:error-percentage="0"
          chart:regression-type="none"
          chart:data-label-number="none"
          chart:data-label-text="false"
          chart:data-label-symbol="false"/>
      <style:graphic-properties
          svg:stroke-width="0.1cm"
          svg:stroke-color="#33cc66"
          draw:marker-start-width="0.35cm"
          draw:marker-end-width="0.35cm"
          draw:fill-color="#993366"/>
      <style:text-properties
          fo:font-family="Arial"
          fo:font-size="7.3pt"
          style:font-family-generic="swiss"
          style:font-pitch="variable"/>
    </style:style>
    <style:style style:name="wall" style:family="chart">
      <style:graphic-properties
          draw:stroke="none"
          draw:fill="solid"
          draw:fill-color="#d9d9d9"/>
    </style:style>
    <style:style style:name="floor" style:family="chart">
      <style:graphic-properties
          draw:stroke="none"
          draw:fill-color="#999999"/>
    </style:style>
  <office:automatic-styles>
  </office:automatic-styles>
  <office:body>
    <office:chart>
      <chart:chart svg:width="15.7cm" svg:height="8.5cm" chart:class="chart:scatter" chart:style-name="background">
        <chart:plot-area
            chart:style-name="plotarea"
            chart:table-number-list="1"
            svg:x="0.314cm"
            svg:y="0.32cm"
            svg:width="15.126cm"
            svg:height="8.016cm">
          <xsl:attribute name="cell-range-address" namespace="table">
            <xsl:text>Verlauf.$A$6:.$B$</xsl:text>
            <xsl:value-of select="count(e)+5"/>
          </xsl:attribute>
          <chart:axis chart:dimension="x" chart:name="primary-x" chart:style-name="x-axis">
            <chart:categories>
              <xsl:attribute name="cell-range-address" namespace="table">
                <xsl:text>local-table.A2:.A</xsl:text>
                <xsl:value-of select="count(e)+1"/>
              </xsl:attribute>
            </chart:categories>
          </chart:axis>
          <chart:axis chart:dimension="y" chart:name="primary-y" chart:style-name="y-axis">
            <chart:grid chart:class="major"/>
          </chart:axis>
          <chart:series chart:style-name="series">
            <chart:domain/>
            <chart:data-point chart:repeated="3"/><!-- ???? count??? -->
          </chart:series>
          <chart:wall chart:style-name="wall"/>
          <chart:floor chart:style-name="floor"/>
        </chart:plot-area>
        <table:table table:name="local-table">
          <table:table-header-columns>
            <table:table-column/>
          </table:table-header-columns>
          <table:table-columns>
            <table:table-column table:number-columns-repeated="2"/>
          </table:table-columns>
          <table:table-header-rows>
            <table:table-row>
              <table:table-cell/>
              <table:table-cell office:value-type="string" office:string-value="Spalte A"/>
              <table:table-cell office:value-type="string" office:string-value="Spalte B"/>
            </table:table-row>
          </table:table-header-rows>
          <table:table-rows>
            <xsl:for-each select="e">
            <xsl:sort select="@d"/>
            <table:table-row>
              <table:table-cell office:value-type="string">
                <xsl:attribute name="string-value" namespace="office">
                  <xsl:text>Zeile </xsl:text>
                  <xsl:value-of select="position()+1"/>
                </xsl:attribute>
              </table:table-cell>
              <table:table-cell office:value-type="float">
                <xsl:attribute name="value" namespace="office">
                  <xsl:value-of select="((@d div 3600000) + 613560) div 24"/>
                </xsl:attribute>
              </table:table-cell>
              <table:table-cell office:value-type="float" office:value="{@v}"/>
            </table:table-row>
            </xsl:for-each>
          </table:table-rows>
        </table:table>
      </chart:chart>
    </office:chart>
  </office:body>
</office:document-content>

</xsl:template>
</xsl:stylesheet>